clear; 
close all;
clc;

% Problem #1 for introduction to MATLAB
% solution using find
% Given a matrix A with num rows, find the sequence with maximum energy in
% matrix A

num = 3; % number of vectors to be generated, that is number of rows in matrix A

lseq = 10; %length of the sequence (number of matrix columns)

valmax = 20; % the max value of the sequence

for i=1:num
    
    A (i,:) = round(valmax*rand(1,lseq));
    
    evect(i) = seq_energy(A(i,:));
    
end

nrg_max = max(evect); % selects the row with maximum energy

v_ok = A(find(evect==nrg_max),:);

v_ok_index = find(evect==nrg_max);

% print on screen

fprintf('\nThe sequence with maxmum energy is stored in row %d of matrix A\nIts energy is %d\n\n', v_ok_index, nrg_max)

pause

% evaluation of the energy of columns of matrix A

for k=1:size(A,2)
    ecol(k)=seq_energy(A(:,k));
end

ecol = sort(ecol) %<--2;<--4


%pause
fprintf('\nAverage value of energy of sequences defined by columns of A: %d\n', round(mean(ecol)))

ecolsub = find(ecol>(round(mean(ecol))))


bar(ecolsub,ecol(ecolsub))%<--1

xlabel('Column indexes')
ylabel('Sequence energy')
title('Energy of relevant vectors')
    
    
    
    
    
    
    