clear 
close all
clc

% Problem #1 for introduction to MATLAB
% solution using traditional constructs

num = 3; % number of vectors to be generated, that is number of rows in matrix A

lseq = 10;

valmax = 20;

for i=1:num
    for j=1:lseq
        A (i,j) = round(valmax*rand(1,1));
    end
end
for i=1:num
    evect(i) = seq_energy(A(i,:));
end

% find the sequence with maximum energy
nrg_max=0;

for i=1:num
    if evect(i)>nrg_max
        nrg_max=evect(i);
        nrg_max_index=i;
    end
end

% print on screen

fprintf('\nThe sequence with maximum energy is stored in row %d of matrix A\nIts energy is %d\n\n', nrg_max_index, nrg_max)

%pause

% evaluation of the energy of columns of matrix A

for k=1:size(A,2)
    ecol(k)=seq_energy(A(:,k));
end

ecol = sort(ecol); %<--2;<--4


%pause
ecol_threshold=mean(ecol);
fprintf('\nAverage value of energy of sequences defined by columns of A: %0.2f\n', ecol_threshold)
k=1;
for i=1:lseq
    if ecol(i)>ecol_threshold
        ecolsub(k)=i;
        k=k+1;
    end
end

en_above_th=ecol(ecolsub);
bar(ecolsub,en_above_th)%<--1

xlabel('Column indexes')
ylabel('Sequence energy')
title('Energy of relevant vectors')
